﻿using System.Windows;
using Microsoft.Phone.Controls;
using Windows.Networking.Proximity;

namespace _01_Proximity {
    public partial class MainPage : PhoneApplicationPage {
        // Constructor
        public MainPage() {
            InitializeComponent();
        }

        /// <summary>
        /// Start listening for device
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnStart_Click(object sender, RoutedEventArgs e) {
            ProximityDevice nfc = ProximityDevice.GetDefault();
            nfc.DeviceArrived += nfc_DeviceArrived;
            nfc.DeviceDeparted += nfc_DeviceDeparted;
        }

        /// <summary>
        /// Device arrived event
        /// </summary>
        /// <param name="sender"></param>
        void nfc_DeviceArrived(ProximityDevice sender) {
            Dispatcher.BeginInvoke(() =>
            {
                tbxProximityMessage.Text = "Device arrivato";
            });
        }

        /// <summary>
        /// Device departed event
        /// </summary>
        /// <param name="sender"></param>
        void nfc_DeviceDeparted(ProximityDevice sender) {
            Dispatcher.BeginInvoke(() =>
            {
                tbxProximityMessage.Text = "Device allontanato";
            });
        }

    }
}