﻿using System.Runtime.InteropServices.WindowsRuntime;
using System.Windows;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using NdefLibrary.Ndef;
using Windows.Networking.Proximity;
using Windows.Storage.Streams;

namespace _04_Launchapp {
    public partial class MainPage : PhoneApplicationPage {
        private readonly ProximityDevice nfc;
        // Constructor
        public MainPage() {
            InitializeComponent();
            nfc = ProximityDevice.GetDefault();
            nfc.DeviceArrived += nfc_DeviceArrived;
            nfc.SubscribeForMessage("NDEF", MessageReceivedHandler);
        }

        protected override void OnNavigatedTo(NavigationEventArgs e) {
            base.OnNavigatedTo(e);
            if (NavigationContext.QueryString.ContainsKey("DataUri")) {
                Dispatcher.BeginInvoke(() =>
                    {
                        tbxLog.Text = NavigationContext.QueryString["DataUri"];
                    });
            }
        }

        void nfc_DeviceArrived(ProximityDevice sender) {
            Dispatcher.BeginInvoke(() =>
                {
                    btnWriteTag.IsEnabled = true;
                    btnWriteTagURI.IsEnabled = true;
                });
        }

        private void btnWriteTag_Click(object sender, RoutedEventArgs e) {
            var record = new NdefLaunchAppRecord();
            record.Arguments = "param1=0";
            record.AddPlatformAppId("WindowsPhone", "{70cde417-24df-4984-898d-6908d930d04c}");
            NdefMessage message = new NdefMessage();
            message.Add(record);
            nfc.PublishBinaryMessage("NDEF:WriteTag", message.ToByteArray().AsBuffer(), MessageWrittenHandler);
        }


        private void btnWriteTagUri_Click(object sender, RoutedEventArgs e) {
            //Encoding the URL we write (must be Utf16)
            var dataWriter = new DataWriter { UnicodeEncoding = UnicodeEncoding.Utf16LE };
            dataWriter.WriteString("04demo:DataUri=Cdays13");
            var dataBuffer = dataWriter.DetachBuffer();
            // write our data to the tag, handler will get called upon successful transmission
            nfc.PublishBinaryMessage("WindowsUri:WriteTag", dataBuffer, MessageWrittenHandler);
        }

        private void MessageWrittenHandler(ProximityDevice sender, long messageid) {
            Dispatcher.BeginInvoke(() =>
                {
                    nfc.StopPublishingMessage(messageid);
                    MessageBox.Show("Tag Scritto");
                });
        }

        private void MessageReceivedHandler(ProximityDevice sender, ProximityMessage message) {
        }

    }
}